// Anteater.m
//--------------------------------------------------------------------
#import "AntEater.h"
#import "ModelSwarm.h"
//--------------------------------------------------------------------

@implementation Anteater

//--------------------------------------------------------------------

- setEnvironment: mS
   dataWarehouse: dW
       interface: it
      ruleMaster: rp
{

 TRACE2(printf("\n%8X Anteater - entry setEnvironment: %8X\n",
	       (int)self,(int)mS);)
 TRACE2(printf("                             dataWarehouse: %8X\n",(int)dW);)
 TRACE2(printf("                                 interface: %8X\n",(int)it);)
 TRACE2(printf("                                ruleMaster: %8X\n",(int)rp);)

   environment   = mS;
   dataWarehouse = dW;
   interface     = it;
   ruleMaster    = rp;

   TRACE2(printf("\n%8X Anteater - exit setEnvironment %8X\n\n",
                 (int)self,(int)self);)

   return self;

}

//--------------------------------------------------------------------

- createEnd
{

   ModelSwarm * environ;
   id obj;

   TRACE2(printf("\n%8X Anteater - entry createEnd\n",(int)self);)

   environ = (ModelSwarm *) environment;

   world      = [environ getWorld];
   traces     = [environ getTraces];
   worldXSize = (int) [world getSizeX];
   worldYSize = (int) [world getSizeY];

   eaten = tries = sw = 0;

   obj = [super createEnd];

   TRACE2(printf("\n%8X Anteater - exit createEnd %8X\n\n",
                 (int)self,(int)obj);)

   return obj;

}

//--------------------------------------------------------------------

- search
{

   ModelSwarm * environ;
   int    x,y,d,c,t;

   TRACE2(printf("\n%8X Anteater - entry search\n",(int)self);)

   environ = (ModelSwarm *) environment;

   if ([environ getNumberOfAnts] == 0) return self;

   anAnt = [environ getAnAnt];

   x = [environ getAntPosX: anAnt];
   y = [environ getAntPosY: anAnt];
   d = [environ getAntDirection: anAnt];
   c = [environ getAntColor: anAnt];
   t = [traces getValueAtX: x Y: y];

   [interface encodeColor: c trace: t direction: d];
   [ruleMaster applyRuleTo: dataWarehouse with: interface];
   direction = [interface decode];

   if (direction == 0) x++;
   if (direction == 1) y++;
   if (direction == 2) x--;
   if (direction == 3) y--;

   xPos = (x + worldXSize) % worldXSize;
   yPos = (y + worldYSize) % worldYSize;

   TRACE2(printf("\n%8X Anteater - exit search %8X\n\n",
                 (int)self,(int)self);)

   return self;

}

//--------------------------------------------------------------------

- eat
{

   ModelSwarm * environ;
   double w;
   int    x,y;

   TRACE2(printf("\n%8X Anteater - entry eat\n",(int)self);)

   environ = (ModelSwarm *) environment;

   if ([environ getNumberOfAnts] == 0) return self;

   x = [environ getAntPosX: anAnt];
   y = [environ getAntPosY: anAnt];

   w = 0;
   if ((xPos == x) && (yPos == y))
   {

      eaten++;
      [environ dropAnt: anAnt];
      w = 1;

   }

   [ruleMaster setReward: w to: dataWarehouse];

   TRACE2(printf("\n%8X Anteater - exit eat %8X\n\n",
                 (int)self,(int)self);)


   return self;

}

//--------------------------------------------------------------------

- print
{

   [dataWarehouse print];
   return self;

}

//--------------------------------------------------------------------

@end
