// CW_DataWarehouse.h
//--------------------------------------------------------------------

#import <objectbase/SwarmObject.h>
#import <collections.h>
#import <random.h>
#import <math.h>
#import "CW_Message.h"
#import "CW_Effector.h"
#import "CW_Rule.h"
#import "PH_ParmWarehouse.h"
#import "PH_Reader.h"
#import "EH_Trace.h"

//--------------------------------------------------------------------

@interface CW_DataWarehouse: SwarmObject
{

   char             eyeCatcher[4];

   CW_Effector      * activeEffector;
   CW_Message       * lastMemo;
   CW_Treasury      * treasury;
   PH_ParmWarehouse * parmWarehouse;
   PH_Reader        * reader;

   id <SimpleRandomGenerator> theGenerator;
   id <UniformDoubleDist>     theUniformDblRand;
   id <UniformIntegerDist>    theUniformIntRand;

   id ruleList,effectorList,messageList;
   id matchList,winnerList,workList;
   id memoList;

   int selectionCounter,evolutionCounter,errorCounter,
       coverDetectorCounter,coverEffectorCounter,selAfterEvol;

   int numberOfRules,numberOfEffectors,geneLength,effectorsFlag;

   float initialStrength, wildCardRate;
 
   char ruleFileName[64];
   char work[512];

}

//--------------------------------------------------------------------

-                           createEnd;

-                           setParmWarehouse:  (PH_ParmWarehouse *) pr;
-                           setReader:         (PH_Reader        *) pr;
-                           setActiveEffector: (CW_Effector *)      aE;
-                           setLastMemo:       (CW_Message  *)      aM;

- (id)                      getRuleList;
- (id)                      getEffectorList;
- (id)                      getMessageList;
- (id)                      getMatchList;
- (id)                      getWinnerList;
- (id)                      getWorkList;
- (id)                      getMemoList; 
- (id <UniformDoubleDist> ) getUniformDblRand;
- (id <UniformIntegerDist>) getUniformIntRand;
- (CW_Treasury      *)      getTreasury;
- (CW_Effector      *)      getActiveEffector;
- (CW_Message       *)      getLastMemo;         
- (PH_ParmWarehouse *)      getParmWarehouse;
- (int)                     getErrorCounter;
- (int)                     getSelectionCounter;
- (int)                     getSelAfterEvol;

-                           setAtRandom;
-                           loadFromFile;
-                           addSelection;
-                           addEvolution;
-                           addError;
-                           addCoverDetector;
-                           addCoverEffector;

-                           print;

//--------------------------------------------------------------------
@end
