// CW_DataWarehouse.m
//--------------------------------------------------------------------

#import "CW_DataWarehouse.h"

@implementation CW_DataWarehouse

//--------------------------------------------------------------------

- createEnd
{

   int i=0;
   unsigned int theSeed=0;
   id  obj;

TRACE4 (printf("\n%8X DataWarehouse - entry createEnd\n",(int) self);)

   eyeCatcher[0]    = 'D';
   eyeCatcher[1]    = 'W';
   eyeCatcher[2]    = 'H';
   eyeCatcher[3]    = 'S';

   errorCounter     = 0;
   selectionCounter = 0;
   evolutionCounter = 0;
   coverDetectorCounter = 0;
   coverEffectorCounter = 0;
   selAfterEvol = 0;
   activeEffector = (CW_Effector*) self;

   theSeed           = [uniformIntRand getIntegerWithMin: 0 
				       withMax: 999999];
   theGenerator      = [MT19937gen create: [self getZone]
                         setStateFromSeed: theSeed];
   theUniformDblRand = [UniformDoubleDist create: [self getZone]
                                    setGenerator: theGenerator];
   theUniformIntRand = [UniformIntegerDist create: [self getZone]
                                      setGenerator: theGenerator];

   if ([parmWarehouse getParm: "numberOfRules"
                  intoInteger: &numberOfRules] != 0)
   {
       printf("CW_DataWarehouse cannot find numberOfRules\n");i=1;}

   if ([parmWarehouse getParm: "numberOfEffectors"
                  intoInteger: &numberOfEffectors] != 0)
   {
       printf("CW_DataWarehouse cannot find numberOfEffectors\n");
       i=1;
   }

   if ([parmWarehouse getParm: "geneLength"
                  intoInteger: &geneLength] != 0)
   {
       printf("CW_DataWarehouse cannot find geneLength\n");
       i=1;
   }

   if ([parmWarehouse getParm: "effectorsFlag"
                  intoInteger: &effectorsFlag] != 0)
   {
       printf("CW_DataWarehouse cannot find effectorsFlag value\n");
       i=1;
   }

   if ([parmWarehouse getParm: "wildCardRate"
                    intoFloat: &wildCardRate] != 0)
   {
       printf("CW_DataWarehouse cannot find wildCardRate value\n");
       i=1;
   }

   if ([parmWarehouse getParm: "initialStrength"
                    intoFloat: &initialStrength] != 0)
   {
       printf("CW_DataWarehouse cannot find initialStrength value\n");i=1;}

   if (i != 0)
   {
      printf("CW_DataWarehouse cannot find one or more parameters\n");
      exit (0);
   }

   ruleList          = [List create: [self getZone]];
   effectorList      = [List create: [self getZone]];
   messageList       = [List create: [self getZone]];
   matchList         = [List create: [self getZone]];
   winnerList        = [List create: [self getZone]];
   workList          = [List create: [self getZone]];
   memoList          = [List create: [self getZone]];

   treasury          = [CW_Treasury createBegin: [self getZone]];
   treasury          = [treasury    createEnd];

   [self setAtRandom];

   if ([parmWarehouse getParm: "ruleFileName"
                   intoString:  ruleFileName withLength: 64] == 0)
       [self loadFromFile];

   obj               = [super createEnd];

TRACE4 (printf("%8X DataWarehouse exit - createEnd %8X\n\n",
                 (int) self,(int) obj);)

   return obj;

}

//--------------------------------------------------------------------

- setParmWarehouse: (PH_ParmWarehouse *) pr
{

TRACE4(printf("\n%8X DataWareHouse - entry setParmWarehouse: %8X\n",
              (int) self,(int) pr);)

   parmWarehouse = pr;

TRACE4(printf("%8X DataWareHouse - exit setParmWarehouse %8X\n\n",
              (int) self,(int) self);)

   return self;

}

//--------------------------------------------------------------------

- setReader: (PH_Reader *) pr
{

TRACE4(printf("\n%8X DataWareHouse - entry setReader: %8X\n",
              (int) self,(int) pr);)

   reader = pr;

TRACE4(printf("%8X DataWareHouse - exit setReader %8X\n\n",
              (int) self,(int) self);)

   return self;

}

//--------------------------------------------------------------------

- setActiveEffector: (CW_Effector *) aE;
{

TRACE4(printf("\n%8X DataWareHouse - entry setActiveEffector: %8X\n",
              (int) self,(int) aE);)

   activeEffector = aE;

TRACE4(printf("%8X DataWareHouse - exit setActiveEffector %8X\n\n",
              (int) self,(int) self);)

   return self;

}
- setLastMemo:    (CW_Message*) aM {lastMemo = aM; return self;}

//--------------------------------------------------------------------

- (id) getRuleList
{

TRACE4(printf("\n%8X DataWareHouse - entry getRuleList\n",(int) self);)
TRACE4(printf("%8X DataWareHouse - exit getRuleList %8X\n\n",
              (int) self,(int) ruleList);)

   return ruleList;

}

//--------------------------------------------------------------------

- (id) getEffectorList
{

TRACE4(printf("\n%8X DataWareHouse - entry getEffectorList\n",(int) self);)
TRACE4(printf("%8X DataWareHouse - exit getEffectorList %8X\n\n",
              (int) self,(int) effectorList);)

   return effectorList;

}

//--------------------------------------------------------------------

- (id) getMessageList
{

TRACE4(printf("\n%8X DataWareHouse - entry getMessageList\n",(int) self);)
TRACE4(printf("%8X DataWareHouse - exit getMessageList %8X\n\n",
              (int) self,(int) messageList);)

   return messageList;

}

//--------------------------------------------------------------------

- (id) getMatchList
{

TRACE4(printf("\n%8X DataWareHouse - entry getMatchList\n",(int) self);)
TRACE4(printf("%8X DataWareHouse - exit getMatchList %8X\n\n",
              (int) self,(int) matchList);)


   return matchList;

}

//--------------------------------------------------------------------

- (id) getWinnerList
{

TRACE4(printf("\n%8X DataWareHouse - entry getWinnerList\n",(int) self);)
TRACE4(printf("%8X DataWareHouse - exit getWinnerList %8X\n\n",
              (int) self,(int) winnerList);)

   return winnerList;

}

//--------------------------------------------------------------------

- (id) getWorkList
{

TRACE4(printf("\n%8X DataWareHouse - entry getWorkList\n",(int) self);)
TRACE4(printf("%8X DataWareHouse - exit getWorkList %8X\n\n",
              (int) self,(int) workList);)

   return workList;

}

//--------------------------------------------------------------------

- (id) getMemoList {return memoList;}
//--------------------------------------------------------------------

- (CW_Treasury *) getTreasury
{

TRACE4(printf("\n%8X DataWareHouse - entry getTreasury\n",(int) self);)
TRACE4(printf("%8X DataWareHouse - exit getTreasury %8X\n\n",
              (int) self,(int) treasury);)

   return treasury;

}

//--------------------------------------------------------------------

- (CW_Effector *) getActiveEffector
{

TRACE4(printf("\n%8X DataWareHouse - entry getActiveEffector\n",(int) self);)
TRACE4(printf("%8X DataWareHouse - exit getActiveEffector %8X\n\n",
              (int) self,(int) activeEffector);)

   return activeEffector;

}
- (CW_Message*) getLastMemo {return lastMemo;}

//--------------------------------------------------------------------

- (PH_ParmWarehouse *) getParmWarehouse
{

TRACE4(printf("\n%8X DataWareHouse - entry getParmWarehouse\n",
              (int) self);)
TRACE4(printf("%8X DataWareHouse - exit getParmWarehouse %8X\n\n",
              (int) self,(int) parmWarehouse);)

   return parmWarehouse;

}

//--------------------------------------------------------------------


- (id <UniformDoubleDist>) getUniformDblRand
{

TRACE4(printf("\n%8X DataWareHouse - entry getUniformDblRand\n",
              (int) self);)
TRACE4(printf("%8X DataWareHouse - exit getUniformDblRand %8X\n\n",
              (int) self,(int) theUniformDblRand);)

   return theUniformDblRand;

}


//--------------------------------------------------------------------

- (id <UniformIntegerDist>) getUniformIntRand
{

TRACE4(printf("\n%8X DataWareHouse - entry getUniformIntRand\n",
              (int) self);)
TRACE4(printf("%8X DataWareHouse - exit getUniformIntRand %8X\n\n",
              (int) self,(int) theUniformIntRand);)

   return theUniformIntRand;

}

//--------------------------------------------------------------------

- (int) getErrorCounter
{

TRACE4(printf("\n%8X DataWareHouse - entry getErrorCounter\n",(int) self);)
TRACE4(printf("%8X DataWareHouse - exit getErrorCounter %d\n\n",
              (int) self,errorCounter);)

   return  errorCounter;

}

//--------------------------------------------------------------------

- (int) getSelectionCounter;
{

TRACE4(printf("\n%8X DataWareHouse - entry getSelectionCounter\n",
              (int) self);)
TRACE4(printf("%8X DataWareHouse - exit getSelectionCounter %d\n\n",
              (int) self,selectionCounter);)

   return  selectionCounter;

}

//--------------------------------------------------------------------

- (int) getSelAfterEvol;
{

TRACE4(printf("\n%8X DataWareHouse - entry getSelAfterEvol\n",
              (int) self);)
TRACE4(printf("%8X DataWareHouse - exit getSelAfterEvol %d\n\n",
              (int) self,selAfterEvol);)

   return  selAfterEvol;

}

//--------------------------------------------------------------------
//Here we create lot of rules and a set of effector. Each rule own
//two geni: a condition set at random and an action part that can
//also be set at random other with the same value of a condition part
//of an effector picked at random.
//Effectors have an action part and a suggestion; action part is made
//translating the suggestion (is a number) in binary form.

- setAtRandom
{

   CW_Effector * anEffector;
   CW_Rule     * aRule;
   char        * string;
   float         w1,w2,w3;
   int           i=0,j,k=-1,m;

TRACE4 (printf("\n%8X DataWarehouse - entry setAtRandom\n",(int) self);)

   // effectors

   for(i=0;i<numberOfEffectors;i++)
   {

      w1 = (double) i;
      w2 = (double) geneLength;

      for(j=0;j<geneLength;j++)
      {

         w2--;
         w3 = pow(2,w2);
         if (w1 >= w3) {work[j] = '1';w1 = w1 - w3;}
         else work[j] = '0';

      }

      anEffector = [CW_Effector createBegin:   [self getZone]];
                   [anEffector  setLength:     geneLength];
                   [anEffector  setBody:       &work[0]];
                   [anEffector  setSuggestion: i];
      anEffector = [anEffector  createEnd];

      [effectorList addLast: anEffector];

   }

   // rules

   if(effectorsFlag == 1) m = geneLength;
   else m = geneLength*2;

   for(i=0;i<numberOfRules;i++)
   {

      for(j=0;j<m;j++)
      {

         work[j] = '0';
         if ([theUniformIntRand getIntegerWithMin: 0 withMax: 1] == 1)
            work[j] = '1';

         if ([theUniformDblRand getDoubleWithMin: 0 withMax: 1] <
             wildCardRate) work[j] = '#';

      }

      if (effectorsFlag == 1)
      {

         k++;
         if (k >= numberOfEffectors) k = 0;
         anEffector = [effectorList atOffset: k];
         string     = [anEffector getBody];

         for(j=0;j<geneLength;j++) work[j+geneLength] = string[j];

      }

      aRule = [CW_Rule createBegin:  [self getZone]];
              [aRule   setLength:    geneLength];
              [aRule   setCondition: &work[0]];
              [aRule   setAction:    &work[geneLength]];
              [aRule   setStrength:  initialStrength];
              [aRule   setTheUniformDblRand: theUniformDblRand];
      aRule = [aRule   createEnd];

      [ruleList addLast: aRule];

   }

TRACE4 (printf("%8X DataWarehouse exit - setAtRandom %8X\n\n",
                  (int) self,(int) self);)

   return self;

}

//--------------------------------------------------------------------

- loadFromFile
{
   CW_Rule     * aRule;
   int         i,j=0,r=0;

TRACE4(printf("\n%8X CW_DataWarehouse - entry loadFromFile: %8X\n",
              (int) self,(int) rF);)

   if ([reader openFile: ruleFileName] != 0)
   {
      printf("CW_DataWarehouse cannot open file: %s\n",ruleFileName);
      exit (0);
   }

   i = [reader readInto: work withLength: 512];
   while(i == 0)
   {
      j = -1;
      do
      {
        j++;
      } while(work[j] == ' ');

      if((work[j] != '\0') && (work[j] != '/') && (work[j+1] != '/'))
      {
         if (r >= numberOfRules)
         {
            printf("CW_DataWarehouse too rules in file %s\n",
                   ruleFileName);
            exit (0);
         }
         aRule = [ruleList atOffset: r++];
                 [aRule setCondition: &work[j]];
                 [aRule setAction:    &work[geneLength+j]];
      }
      i = [reader readInto: work withLength: 512];
   }

   if (i != 1)
   {
      printf("CW_DataWarehouse error in reading file %s\n",
             ruleFileName);
      exit(0);
   }

   [reader closeFile];

TRACE4(printf("%8X CW_DataWarehouse - exit loadFromFile %8X\n\n",
              (int) self,(int) self);)

   return self;

}

//--------------------------------------------------------------------

- addSelection
{

TRACE4(printf("\n%8X DataWareHouse - entry addSelection\n",(int) self);)

   selectionCounter++;
   selAfterEvol++;

TRACE4(printf("%8X DataWareHouse - exit addSelection %8X\n\n",
              (int) self,(int) self);)

   return self;

}

//--------------------------------------------------------------------

- addEvolution
{

TRACE4(printf("\n%8X DataWareHouse - entry addEvolution\n",(int) self);)

   evolutionCounter++;
   errorCounter = 0;
   selAfterEvol = 0;

TRACE4(printf("%8X DataWareHouse - exit addEvolution %8X\n\n",
              (int) self,(int) self);)

   return self;

}

//--------------------------------------------------------------------

-  addError;
{

TRACE4(printf("\n%8X DataWareHouse - entry addError\n",
              (int) self);)

   errorCounter++;

TRACE4(printf("%8X DataWareHouse - exit addError %8X\n\n",
              (int) self,(int) self);)

   return  self;

}

//--------------------------------------------------------------------

-  addCoverDetector;
{

TRACE4(printf("\n%8X DataWareHouse - entry addCoverDetector\n",
              (int) self);)

   coverDetectorCounter++;

TRACE4(printf("%8X DataWareHouse - exit addCoverDetector %8X\n\n",
              (int) self,(int) self);)

   return  self;

}

//--------------------------------------------------------------------

-  addCoverEffector;
{

TRACE4(printf("\n%8X DataWareHouse - entry addCoverEffector\n",
              (int) self);)

   coverEffectorCounter++;

TRACE4(printf("%8X DataWareHouse - exit addCoverEffector %8X\n\n",
              (int) self,(int) self);)

   return  self;

}

//--------------------------------------------------------------------

- print
{

   printf("\n%8X - DataWarehouse cointains following data:\n",(int) self);

   printf("%8X - RuleList contains %d rules:\n",
          (int) ruleList,[ruleList getCount]);
   [ruleList forEach: M(print)];
   printf("\n");

   printf("%8X - EffectorList contains %d effectors:\n",
          (int) effectorList,[effectorList getCount]);
   [effectorList forEach: M(print)];
   printf("\n");

   printf("%8X - MessageList contains %d messages:\n",
          (int) messageList,[messageList getCount]);
   [messageList forEach: M(print)];
   printf("\n");

   printf("%8X - MatchList contains %d rules:\n",
          (int) matchList,[matchList getCount]);
   [matchList forEach: M(print)];
   printf("\n");

   printf("%8X - WinnerList contains %d rules:\n",
          (int) winnerList,[winnerList getCount]);
   [winnerList forEach: M(print)];
   printf("\n");

   printf("%8X - WorkList contains %d rules:\n",
          (int) workList,[workList getCount]);
   [workList forEach: M(print)];
   printf("\n");

   printf("%8X - MemoList contains %d messages:\n",
          (int) memoList,[memoList getCount]);
   [memoList forEach: M(print)];
   printf("\n");

   printf("%8X - Treasury balance:\n",(int) treasury);
   [treasury print];
   printf("\n");

   if(activeEffector != (CW_Effector*) self)
     {
       printf("current active effector is: \n");
       [activeEffector print];
       printf("\n");
     }
   printf("Statistics:\n");
   printf("Rule's selection has been performed %d times\n",
          selectionCounter);
   printf("CoverDetector has been applied %d times\n",
          coverDetectorCounter);
   printf("CoverEffector has been applied %d times\n",
          coverEffectorCounter);
   printf("Rule's genetic evolution has been performed %d times\n",
          evolutionCounter);

   return self;

}

//--------------------------------------------------------------------
@end
