// CW_Rule.h
//--------------------------------------------------------------------

#import <objectbase/SwarmObject.h>
#import <random.h>
#import <collections.h>
#import "CW_Message.h"
#import "CW_Treasury.h"
#import "EH_Dump.h"
#import "EH_Trace.h"

//--------------------------------------------------------------------
@interface CW_Rule: SwarmObject

{

   char    eyeCatcher[4];
   id <UniformDoubleDist> theUniformDblRand;
   id      partnerList;
   EH_Dump *  dump;
   double  strength,bid,eBid,specificity;
   int     length;
   char    condition[256];
   char    action[256];

}

//--------------------------------------------------------------------

-          createEnd;
- (void)   drop;

-          setTheUniformDblRand: (id<UniformDoubleDist>) uR;
-          setCondition:         (char *)                aS;
-          setAction:            (char *)                aS;
-          setLength:            (int)                   ll;
-          setStrength:          (double)                ss;
-          setDump:              (EH_Dump *)             du;
- (char *) getCondition;
- (char *) getAction;
- (double) getStrength;
- (double) getEBid;

- (int)    matchMessage: (CW_Message *) me;
-          resetPartnerList;
-          modifyConditionTo: (char *) aS;
-          modifyActionTo:    (char *) aS;
-          bidWithRatio: (float) bR lBid1: (float) l1 lBid2: (float) l2
                 eLBid1: (float) e1 eLBid2: (float) e2
               bidSigma: (float) bS bidMu: (float) bM;
-          payTaxOf: (float) tR to: (CW_Treasury *) tr;
- (char *) payAndFire;
-          cash: (double) rw;

-          print;
//--------------------------------------------------------------------
@end
