// CW_RuleMaker.h
//--------------------------------------------------------------------

#import <objectbase/SwarmObject.h>
#import <collections.h>
#import <random.h>
#import "CW_DataWarehouse.h"
#import "CW_Message.h"
#import "CW_Shuffler.h"
#import "CW_Rule.h"
#import "PH_ParmWarehouse.h"
#import "EH_Dump.h"
#import "EH_Trace.h"

@interface CW_RuleMaker: SwarmObject

//--------------------------------------------------------------------

{

   char             eyeCatcher[4];
   CW_DataWarehouse  * dataWarehouse;
   CW_Shuffler       * shuffler;
   PH_ParmWarehouse  * parmWarehouse;
   EH_Dump           * dump;
   id <UniformDoubleDist>  aUniformDblRand;
   id <UniformIntegerDist> aUniformIntRand;
   id ruleList,messageList,treasury;
   int geneLength,numberOfRules,couplesToSelect,effectorsFlag,
       numberOfMessages,verifyNews,shuffleFlag;
   float wildCardRate,turnoverRate,crossoverRate,mutationRate,
         crowdingRate,crowdingFactor;
   double totalStrength;
   char   work1[512];
   char   work2[512];
   CW_Rule * parent1;
   CW_Rule * parent2;
   CW_Rule * child1;
   CW_Rule * child2;

}

//--------------------------------------------------------------------

// public methods

-             createEnd;
-             evolveDataWarehouse:  (CW_DataWarehouse *) dW;
-             setDump:              (EH_Dump *)          du;
-             setShuffler:          (CW_Shuffler *)      sh;

//--------------------------------------------------------------------

// internal usage methods

-             keepData;
- (CW_Rule *) selectBest;
-             removeWorstMatching: (CW_Rule *) ch;
-             crossAndMutate;
- (int)       verify;

//--------------------------------------------------------------------
@end
