// CW_RuleMaster.h
//--------------------------------------------------------------------

#import <objectbase/SwarmObject.h>
#import <collections.h>
#import <random.h>
#import "CW_DataWarehouse.h"
#import "CW_RuleMaker.h"
#import "CW_Effector.h"
#import "CW_Message.h"
#import "CW_Rule.h"
#import "CW_Shuffler.h"
#import "PH_ParmWarehouse.h"
#import "EH_Dump.h"
#import "EH_Trace.h"

//--------------------------------------------------------------------

@interface CW_RuleMaster: SwarmObject
{
   char             eyeCatcher[4];
   id <UniformDoubleDist>  aUniformDblRand;
   id <UniformIntegerDist> aUniformIntRand;
   id               ruleList,messageList,matchList,winnerList;
   id               effectorList,workList;
   id               memoList;
   CW_RuleMaker     * ruleMaker;
   CW_DataWarehouse * dataWarehouse;
   id               interface;
   PH_ParmWarehouse * parmWarehouse;
   CW_Treasury       * treasury;
   EH_Dump           * dump;
   CW_Shuffler       * shuffler;
   CW_Rule           * ruleWithBestMatch;
   CW_Rule           * ruleWithBestAction;
   CW_Message        * bestMessage;
   CW_Effector       * highMatchEffector;
   CW_Effector       * activeEffector;
   char * eventsMap;
   char * eventList;
   float bidRatio,lBid1,lBid2,eLBid1,eLBid2,bidSigma,bidMu,confidence;
   float evolutionRate,lifeTaxRate,bidTaxRate,evaluationConfidence,
         evaluationRate;
   int geneLength,suggestion,bestMatch,errorCounter,selAfterEvol,
       maxNumberOfMessages,shuffleFlag,maxMemory;

}

//--------------------------------------------------------------------

// public methods

-       createEnd;
-       setRuleMaker: (CW_RuleMaker *)     rM;
-       applyRuleTo:  (CW_DataWarehouse *) dW with: (id) it;
-       setReward:    (double) rV to: (CW_DataWarehouse *) dW;
-       setDump:      (EH_Dump *) du;
-       setShuffler:  (CW_Shuffler *) sh;

//--------------------------------------------------------------------
// internal usage methods

-       keepData;
-       detect;
-       matchRule;
-       coverDetector;
-       matchEffector;
-       coverEffector;
-       doAnAuction;
-       collectTaxes;
-       fire;
-       choose;

//--------------------------------------------------------------------
@end
