// ModelSwarm.h
//--------------------------------------------------------------------
#import <objectbase/Swarm.h>
#import <space.h>
#import <random.h>
#import <activity.h>
#import <collections.h>
#import "EH_Trace.h"
#import "EH_Dump.h"
#import "CW_Shuffler.h"
#import "CW_RuleMaker.h"
#import "CW_RuleMaster.h"
#import "PH_ParmWarehouse.h"
#import "PH_Reader.h"
#import "CW_DataWarehouse.h"
#import "CW_Interface.h"
#import "TraceSpace.h"
#import "MoGrid2d.h"
#import "Ant.h"
#import "AntEater.h"

//--------------------------------------------------------------------

@interface ModelSwarm: Swarm
{

  id antList;
  id modelActions;
  id modelSchedule;
  MoGrid2d      * world;
  TraceSpace    * traces;
  Anteater      * anteater;
  float exAnteTraceProb;
  float reproductionRate;
  int   worldXSize, worldYSize,
        initialGeneration,maxNumberOfAnts,maxNumberOfQueens,
        numberOfQueens,eatenAnts,verificationTreshold,attempts,
        successes,printFlag,noAnts;

}

//--------------------------------------------------------------------

- getWorld;
- getTraces;
- getAntList;
- (Ant *) getAnAnt;
- (int) getAntPosX: aA;
- (int) getAntPosY: aA;
- (int) getAntDirection: aA;
- (int) getAntColor: aA;
- (int) getNumberOfAnts;
- (int) getNumberOfQueens;
- (int) getEatenAnts;
- (int) getRoomForAnts;
- (int) getRoomForQueens;
- addAnt: aA;
- dropAnt: aA;

+ createBegin: aZone;
- createEnd;
- buildObjects;
- buildActions;
- activateIn: swarmContext;

- verify;

//--------------------------------------------------------------------

@end
