// ObserverSwarm.h
//--------------------------------------------------------------------

#import "ModelSwarm.h"
#import <simtoolsgui/GUISwarm.h>
#import <simtoolsgui.h>
#import <activity.h>
#import <analysis.h>

//--------------------------------------------------------------------

@interface ObserverSwarm: GUISwarm
{

  id displayActions;
  id controlActions;
  id displaySchedule;
  id antGraph;

  id <Colormap>   colorMap;             // allocate colours
  id <ZoomRaster> worldRaster;          // 2d display widget
  id <Value2dDisplay>  traceDisplay;    // display the traces
  id <Object2dDisplay> agentDisplay;    // display the agents

  ModelSwarm * modelSwarm;

  int displayFrequency, zoomFactor;

}

//--------------------------------------------------------------------
// Methods overriden to make the Swarm.

+ createBegin: aZone;
- createEnd;
- buildObjects;
- buildActions;
- activateIn: swarmContext;

//--------------------------------------------------------------------

@end
